<template>
  <div class="mb-4">
    <label class="block mb-2">Select fields to include in query captures:</label>
    <div v-for="field in fields" :key="field" class="flex items-center mb-1">
      <input type="checkbox" :id="field" :value="field" v-model="selectedFields" class="mr-2"
        :class="{ 'bg-gray-800 text-white': isDarkMode }" />
      <label :for="field">{{ field }}</label>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from 'vue';

export default defineComponent({
  name: 'FieldSelector',
  emits: ['fields-changed'],
  props: {
    fields: {
      type: Array as () => string[],
      required: true,
    },
    isDarkMode: {
      type: Boolean,
      required: true,
    },
  },
  setup(props, { emit }) {
    const selectedFields = ref<string[]>([]);

    watch(selectedFields, (newFields) => {
      emit('fields-changed', newFields);
    });

    return {
      selectedFields,
    };
  },
});
</script>